/* 
 * prototype for API
 * $Id: OmniRpc.h,v 1.1.1.1 2004-11-03 21:01:36 yoshihiro Exp $
 */
#include <stdarg.h>

#define OMRPC_OK 0
#define OMRPC_ERROR (-1)

#define INSPECT_PACKET 0

/* low-level and no-MT API */
typedef void *OmniRpcExecHandle;

void OmniRpcExecInit(int *argc, char **argv[]);
void OmniRpcExecFinalize(void);
int OmniRpcExecLocal(char *prog_name, char *func_name, ...);
int OmniRpcExecRemote(char *host, char *prog_name, char *func_name, ...);
int OmniRpcExecRemoteByUser(char *host, char *user_name, char *prog_name, char *func_name, ...);

OmniRpcExecHandle OmniRpcExecOnHost(char *host_name,char *prog_name);
OmniRpcExecHandle OmniRpcExecOnHostByUser(char *host_name,char *user_name,char *prog_name);
int OmniRpcExecCall(OmniRpcExecHandle handle, char *func_name, ...);
void OmniRpcExecTerminate(OmniRpcExecHandle handle);

int OmniRpcModuleInit(char *module_name,...);
void OmniRpcModuleInitV(char *module_name,va_list ap);

/* RPC API */
typedef void *OmniRpcRequest;

void OmniRpcInit(int *argc, char **argv[]);
void OmniRpcFinalize(void);
void OmniRpcInitMPIS(int *argc, char **argv[]);
void OmniRpcFinalizeMPIS(void);

int OmniRpcCall(char *entry_name,...);
int OmniRpcCallV(char *entry_name,va_list ap);
OmniRpcRequest OmniRpcCallAsync(char *entry_name,...);
void *OmniRpcCallAsyncV(char *entry_name,va_list ap);
void OmniRpcWait(OmniRpcRequest req);
int OmniRpcProbe(OmniRpcRequest req);
void OmniRpcWaitAll(int n, OmniRpcRequest reqs[]);
int OmniRpcWaitAny(int n, OmniRpcRequest reqs[]);
void *OmniRpcCallAsyncMPI(char *entry_name,int nprocs,...);
void *OmniRpcCallAsyncMPIS(char *entry_name,int nprocs,...);
void *OmniRpcCallAsyncVMPI(char *entry_name,int nprocs,va_list ap);

typedef void *OmniRpcHandle;

OmniRpcHandle OmniRpcCreateHandle(char *host_name, char *module_name);
int OmniRpcCallByHandle(OmniRpcHandle handle,char *entry_name,...);
OmniRpcRequest OmniRpcCallAsyncByHandle(OmniRpcHandle handle,char *entry_name,...);
int OmniRpcCallByHandleV(OmniRpcHandle handle, char *entry_name,va_list ap);
OmniRpcRequest OmniRpcCallAsyncByHandleV(OmniRpcHandle handle, 
					 char *entry_name,va_list ap);
void OmniRpcDestroyHandle(OmniRpcHandle handle);
void OmniRpcDestroyRequest(OmniRpcRequest req0);


