#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define PATH_MAX 256

void print_header(FILE *fp, char *module_name, char **objs, int nobj);
void print_idl_def(FILE *fp, char *obj);

int main(int argc, char **argv)
{
  int  i, len;
  char module_name[PATH_MAX], file_name[PATH_MAX];
  FILE *fp;

  if(argc<=1){
    fprintf(stderr,"usage: ./prog file1.idl file2.idl ... \n");
  }

  for(i=1; i<argc; i++){
    printf("FILE %3d: %s\n",i,argv[i]);
  }

  sprintf(module_name,"tmp\0");
  sprintf(file_name,"%s.idl\0",module_name);
  printf("OUTPUT  : \"%s\"\n",file_name);

  fp=fopen(file_name,"w");
  print_header(fp, module_name, &(argv[1]), argc-1);
  fclose(fp);

  for(i=1;i<argc;i++){
    fp=fopen(file_name,"a");
    print_idl_def(fp, argv[i]);
    fclose(fp);
  }
} /* main */

void print_header(FILE *fp, char *module_name, char **objs, int nobj)
{
  int i, len;
  char func_name[PATH_MAX];

  fprintf(fp,"Module %s;\n\n",module_name);

  fprintf(fp,"Globals {\n\
#include <Yml/Worker/worker.h>\n\
#include<limits.h>\n\
#include\"xmp_header.h\"\n\
struct droperation\n\
{\n\
    char*          mHost;\n\
    unsigned short mPort;\n\
    char*          mUri;\n\
    uint8          mIsPacked;\n\
};\n\
typedef struct droperation droperation_t;\n\
struct worker\n\
{\n\
    drclient_t mClient;\n\
    char mInitialWorkingDir[PATH_MAX];\n\
    char mWorkingDir[PATH_MAX];\n\
    char* mWorkDescription;\n\
    uint32 mWorkDescriptionSize;\n\
    char* mBinaryName;\n\
\n\
    char** mParameters;\n\
    uint32 mParameterCurrent;\n\
    uint32 mParameterCount;\n\
\n\
    droperation_t* mImports;\n\
    uint32 mImportCurrent;\n\
    uint32 mImportCount;\n\
\n\
    droperation_t mExport;\n\
    droperation_t mAdmin;\n\
    uint8 mXmlErrorDetected;\n\
};\n\
typedef struct worker* worker_t;\n\
extern int worker_init(worker_t* context, char* data, uint32 dataSize, drclient_t client);\n\
extern int worker_import_resources(worker_t context);\n\
extern int worker_export_resouces(worker_t context);\n\
");

  for(i=0;i<nobj;i++){
    len=strlen(objs[i])-strlen(".idl");
    if(len<=0) continue;
    memset(func_name, 0, PATH_MAX);
    memcpy(func_name, objs[i], len);
    fprintf(fp,"extern void main_%s(int argc,char **argv);\n",func_name);
  }
  fprintf(fp,"}\n");

} /* print_header */

void print_idl_def(FILE *fp, char *obj)
{
  char l[1024];
  FILE *fp_in;

  fp_in=fopen(obj,"r");

  // ---- Skip header ----
  while(fgets(l,1024,fp_in)){
    if(!strncmp(l,"Define",6)) break;
  }

  if(strncmp(l,"Define",6)){
    fprintf(stderr,"WARNING : FILE %s doesn't include Definition\n",obj);
    fprintf(stderr,"WARNING : FILE %s is skipped\n",obj);
    return;
  }

  // ---- Print Definition -----
  fprintf(fp,"%s",l);
  while(fgets(l,1024,fp_in)){
    fprintf(fp,"%s",l);
  }

  fclose(fp_in);
 
  return;
} /* print_idl_def */
